let fibonacciFor = [0, 1];
let fibonacciWhile = [0, 1];
let fibonacciDoWhile = [0, 1];

function fibonacciForLoop(fibonacciArray) {
    // Calculate fibonacci for 100 times in a for-loop
    console.time("fibonacciArray")
    for(let i = 0; i < 100 - 2;i++) {
        let cache = fibonacciArray[i];
        let result = cache + fibonacciArray[i+1];
        // Push the new result into the array
        fibonacciArray.push(result);
    }
    console.timeEnd("fibonacciArray")
    console.log(`Fibonacci with for loop: ${fibonacciArray}`);
}

function fibonacciWhileLoop(fibonacciArray) {
    let i = 0;
    console.time("fibonacciArray")
    while(i < 100 - 2) {
        let cache = fibonacciArray[i];
        let result = cache + fibonacciArray[i+1];
        // Push the new result into the array
        fibonacciArray.push(result);
        i++;
    }
    console.timeEnd("fibonacciArray")
    console.log(`Fibonacci with while loop: ${fibonacciArray}`);
}

function fibonacciDoWhileLoop(fibonacciArray) {
    let i = 0;
    console.time('fibonacciArray');
    do {
        let cache = fibonacciArray[i];
        let result = cache + fibonacciArray[i+1];
        // Push the new result into the array
        fibonacciArray.push(result);
        i++;
    } while (i < 100 - 2);

    console.timeEnd("fibonacciArray")
    console.log(`Fibonacci with do while loop: ${fibonacciArray}`);
}

fibonacciForLoop(fibonacciFor);
fibonacciWhileLoop(fibonacciWhile);
fibonacciDoWhileLoop(fibonacciDoWhile);